/*
 * cube.cpp
 *
 *  Created on: 4 mars 2018
 *      Author: ros
 */

#include "Cube.h"

Cube::Cube():Random_object() {

	type_object = "box";
	this->width = this->RandomFloat(min_width, max_width);
	this->height = this->RandomFloat(min_height, max_height);
	this->length = this->RandomFloat(min_length, max_length);
	this->mass = this->width * this->height * this->length * this->mv;
}

Cube::~Cube() {

}


std::string Cube::getSdf() {
	std::string sdf =
					this->get_sdf_header() + "\
				      <collision name ='collision'> \
				        <geometry> \
				          <box><size>"+ std::to_string(this->length) +" "+ std::to_string(this->width) +" "+ std::to_string(this->height) +"</size></box> \
				        </geometry> \
				         <surface> \
				        <friction> \
				          <ode> \
				            <mu>"+ std::to_string(this->mu) +"</mu> \
				            <mu2>"+ std::to_string(this->mu2) +"</mu2> \
				          </ode> \
				        </friction> \
				      </surface> \
				      </collision> \
				      <visual name ='visual'> \
				        <geometry> \
				          <box><size>"+ std::to_string(this->length) +" "+ std::to_string(this->width) +" "+ std::to_string(this->height) +"</size></box> \
				        </geometry> \
				      </visual> \
				      <inertial> \
				        <mass>"+ std::to_string(this->mass) +"</mass> \
				      </inertial> \
				    </link>  " +
					this->get_sdf_footer() ;

	return sdf;
}

std::string Cube::printDataSize() {

	std::string s;
	s = std::to_string(this->length) + ";" + std::to_string(this->width) + ";" + std::to_string(this->height) + ";" ;
	return s;

}
