/*
 * cube.cpp
 *
 *  Created on: 4 mars 2018
 *      Author: ros
 */

#include "Cylinder.h"
#include <math.h>
#define M_PI           3.14159265358979323846

Cylinder::Cylinder():Random_object() {

	type_object = "Cylinder";
	this->radius = this->RandomFloat(min_radius, max_radius);
	this->length = this->RandomFloat(min_length, max_length);
	this->mass = M_PI * pow((this->radius *2),2) * this->length * this->mv;
	this->rot_pos_z = 0;
}

Cylinder::~Cylinder() {

}


std::string Cylinder::getSdf() {
	std::string sdf =
					this->get_sdf_header() + "\
				      <collision name ='collision'> \
				        <geometry> \
				          <cylinder><radius>"+ std::to_string(this->radius)+"</radius><length>"+ std::to_string(this->length)+"</length></cylinder> \
				        </geometry> \
				         <surface> \
				        <friction> \
				          <ode> \
				            <mu>"+ std::to_string(this->mu) +"</mu> \
				            <mu2>"+ std::to_string(this->mu2) +"</mu2> \
				          </ode> \
				        </friction> \
				      </surface> \
				      </collision> \
				      <visual name ='visual'> \
				        <geometry> \
				          <cylinder><radius>"+ std::to_string(this->radius)+"</radius><length>"+ std::to_string(this->length)+"</length></cylinder> \
				        </geometry> \
				      </visual> \
				      <inertial> \
				        <mass>"+ std::to_string(this->mass) +"</mass> \
				      </inertial> \
				    </link>  " +
					this->get_sdf_footer() ;

	return sdf;
}

std::string Cylinder::printDataSize() {

	std::string s;
	s = "0.0;" + std::to_string(this->length) + ";" + std::to_string(this->radius) + ";" ;
	return s;

}


