/*
 * Randomobject.h
 *
 *  Created on: 4 mars 2018
 *      Author: ros
 */

#include <string>

#ifndef RANDOMOBJECT_H_
#define RANDOMOBJECT_H_

class Random_object {
public:
	Random_object();
	virtual ~Random_object();
	virtual std::string getSdf();
	virtual std::string printDataSize();


	float RandomFloat(float, float);

	std::string get_sdf_header();
	std::string get_sdf_footer();

	const std::string& getModelName() const {
		return model_name;
	}

	void setModelName(const std::string& modelName = "") {
		model_name = modelName;
	}

	const std::string& getTypeObject() const {
		return type_object;
	}

	float getMass() const {
		return mass;
	}

	int getMaterial() const {
		return material;
	}

	float getPosX() const {
		return pos_x;
	}

	float getPosY() const {
		return pos_y;
	}

	float getPosZ() const {
		return pos_z;
	}

	float getRotPosX() const {
		return rot_pos_x;
	}

	float getRotPosY() const {
		return rot_pos_y;
	}

	float getRotPosZ() const {
		return rot_pos_z;
	}

protected:

	float mass;
	float mu; //is the Coulomb friction coefficient for the first friction direction
	float mu2; //is the friction coefficient for the second friction direction (perpendicular to the first friction direction).
	int material;

	std::string type_object="";

	float pos_x = 0.0;
	float pos_y = 0.0;
	float pos_z = 0.0;

	float min_pos_x = 0.0;
	float min_pos_y = 0.0;
	float min_pos_z = 0.0;

	float max_pos_x = 0.0;
	float max_pos_y = 0.0;
	float max_pos_z = 0.0;

	float rot_pos_x = 0.0;
	float rot_pos_y = 0.0;
	float rot_pos_z = 0.5;

	float min_rot_pos_x = 0.0;
	float min_rot_pos_y = 0.0;
	float min_rot_pos_z = -1.0;

	float max_rot_pos_x = 0.0;
	float max_rot_pos_y = 0.0;
	float max_rot_pos_z = +1.0;

	float mv = 1.0;  //masse volumique

	std::string model_name="";

};

#endif /* RANDOMOBJECT_H_ */
