/*
 * cube.cpp
 *
 *  Created on: 4 mars 2018
 *      Author: ros
 */

#include "Sphere.h"
#include <math.h>
#define M_PI           3.14159265358979323846

Sphere::Sphere():Random_object() {

	type_object = "Sphere";
	this->radius = this->RandomFloat(min_radius, max_radius);
	this->mass = ((4 *M_PI)/3) * pow((this->radius *2),3)  * this->mv;
	this->rot_pos_z = 0;
}

Sphere::~Sphere() {

}


std::string Sphere::getSdf() {
	std::string sdf =
					this->get_sdf_header() + "\
				      <collision name ='collision'> \
				        <geometry> \
				          <sphere><radius>"+ std::to_string(this->radius)+"</radius></sphere> \
				        </geometry> \
				         <surface> \
				        <friction> \
				          <ode> \
				            <mu>"+ std::to_string(this->mu) +"</mu> \
				            <mu2>"+ std::to_string(this->mu2) +"</mu2> \
				          </ode> \
				        </friction> \
				      </surface> \
				      </collision> \
				      <visual name ='visual'> \
				        <geometry> \
				          <sphere><radius>"+ std::to_string(this->radius)+"</radius></sphere> \
				        </geometry> \
				      </visual> \
				      <inertial> \
				        <mass>"+ std::to_string(this->mass) +"</mass> \
				      </inertial> \
				    </link>  " +
					this->get_sdf_footer() ;

	return sdf;
}

std::string Sphere::printDataSize() {

	std::string s;
	s = "0.0; 0.0 ;" + std::to_string(this->radius) + ";" ;
	return s;

}
