#include <functional>
#include <gazebo/gazebo.hh>
#include <gazebo/physics/physics.hh>
#include <gazebo/common/common.hh>
#include <ignition/math/Vector3.hh>

namespace gazebo
{
  class Traject_object : public ModelPlugin
  {
    public: void Load(physics::ModelPtr _parent, sdf::ElementPtr /*_sdf*/)
    {
      // Store the pointer to the model
      this->model = _parent;

      // Listen to the update event. This event is broadcast every
      // simulation iteration.
      this->updateConnection = event::Events::ConnectWorldUpdateBegin(
          std::bind(&Traject_object::OnUpdate, this));
    }

    // Called by the world update start event
    public: void OnUpdate()
    {
      // Apply a small linear velocity to the model.

      gazebo::math::Pose pose = this->model->GetWorldPose();

      std::cout << "pos(x,y,z) rot (w,x,y,z) = "
    		  "(" << pose.pos.x <<  " , " << pose.pos.y <<  " , " << pose.pos.z << ")"
    		  "(" << pose.rot.w <<  " , " << pose.rot.x <<  " , " << pose.rot.y <<  " , " <<  pose.rot.z << ")"
    		   << std::endl;
    }

    // Pointer to the model
    private: physics::ModelPtr model;

    // Pointer to the update event connection
    private: event::ConnectionPtr updateConnection;
  };

  // Register this plugin with the simulator
  GZ_REGISTER_MODEL_PLUGIN(Traject_object)
}
